import { Meta, Canvas, Controls } from "@storybook/blocks";
import * as ComponentStories from "./text-lines-limit.stories";

<Meta of={ComponentStories} name="Docs" />

# Text Lines Limit

DEPRECATED: This component is deprecated and will be removed in the next major release.
Please use the `ux-text-lines-limit` component instead.
See (Docs)[https://docs.ux.trumpf.com/uxuicore/main/?path=/docs/utilities-text-lines-limit--docs]

## Single Element in Slot

Use the `ux-iws-text-lines-limit` to wrap an HTML element containing text that needs to be
reduced to a specific number of lines. <br />
Use the attributes `text-lines-s`, `text-lines-m`, `text-lines-l`, `text-lines-xl` in order to
change the default number of lines for the different breakpoints. <br />
The default of all these attribues is `0`. `0` acts like a reset: there will be no cropping for those
viewports where the relative attribute is omitted, or where it's value is set to `0`. <br />
If the number of lines is equal in all viewports, use the `text-lines` attribute, specifying the number of lines,
and this will be valid for all viewports.

<ux-table class="ux-u-mt-xxs" full-width>
    <table>
        <thead>
            <th>breakpoints</th>
            <th>max-width 767px</th>
            <th>min-width 768px</th>
            <th>min-width 1024px</th>
            <th>min-width 1440px</th>
        </thead>
        <tbody>
            <td>
                <b>Responsible attribute</b>
            </td>
            <td>text-lines-s</td>
            <td>text-lines-m</td>
            <td>text-lines-l</td>
            <td>text-lines-xl</td>
        </tbody>
    </table>
</ux-table>

<Canvas of={ComponentStories.Default}></Canvas>

## Two different inline Elements

If the element that needs to be cut needs to be displayed inline after another element, wrap the two elements
inside a wrapper element and set on the `ux-iws-text-lines-limit` the attribute `nested-element-selector`,
which is a css selector for the element that needs to be cropped.

<Canvas of={ComponentStories.Nested}></Canvas>

## Expand

Use the prop `expand` on the component if it should have a minimum amount of text lines but expand
to more lines should the outer container element have a height that allows it to do so.

<Canvas of={ComponentStories.Expand}></Canvas>

## Collapse

Use the prop `collapse` on the component if it should crop the text only when necessary without setting
a fixed height to the element.

In this example both the card healdines are wrapped around a `ux-iws-text-lines-limit` but this only kicks in
in the second card because in the first example the text is short and it does not need any cropping.

In this story can be seen how the `ux-iws-text-lines-limit` component is used with `collapse` for the title,
and `expand` for the normal text.

<Canvas of={ComponentStories.Collapse}></Canvas>

## With Read more message

Use the attribute `read-more-text` attribute to add the read more functionality to the component.
The component will display the text passed with the attribute at the end of the cropped text.
Clicking onn this flag will make the whole text appear.

<Canvas of={ComponentStories.ReadMore}></Canvas>

## Integration

```
<ux-iws-text-lines-limit
    text-lines-s="3"
    text-lines-m="4"
    text-lines-l="3"
    text-lines-xl="5"
>
    <p class="ux-u-m-s">
        Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium
        doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore
        veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim
        ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia
        consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque
        porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci
        velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore
        magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exerci
        tationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi
        consequatur?
    </p>
</ux-iws-text-lines-limit>
```

## Developer Documentation

<Controls />
